<script>
import { minValue, required, requiredIf } from 'vuelidate/lib/validators';
import { settingService,outletService } from '../../../services'
import { error_message, success_message } from '../../../Helper/helper';
import config from '../../../config';

export default {
  data() {
    return {
        config:config,
        setting: {
            delivery_payment_option:'',
            pickup_payment_option:'',
            dine_in_payment_option:''
        },
        payment_method_option:
        [
            { value: '', text: this.trans.get('__JSON__.Please select an option') },
            { value: 'Both', text: this.trans.get('__JSON__.Both') },
            { value: 'COD', text: this.trans.get('__JSON__.Cash On Delivery')},
            { value: 'PAY ONLINE', text: this.trans.get('__JSON__.PAY ONLINE')}
        ],
        isDeliveryDisplay:false,
        isPickupDisplay:false,
        isDineinDisplay:false,
    };
  },
  mounted(){
    this.getRestaurant();
    this.getSetting();
  },
  validations:{
    setting: {
        delivery_payment_option:{
            required: requiredIf(function() {
                return this.isDeliveryDisplay == 'true'
            }),
        },
        pickup_payment_option:{
            required: requiredIf(function() {
                return this.isPickupDisplay == 'true'
            }),
        },
        dine_in_payment_option:{
            required: requiredIf(function() {
                return this.isDineinDisplay == 'true'
            }),
        },
    },
  },
  methods: {
    getSetting(){
        settingService.getSetting().then((response) => {
            if (response.data.code === 200) {
                this.setting.delivery_payment_option = response.data.result.delivery_payment_option??'',
                this.setting.pickup_payment_option = response.data.result.pickup_payment_option??'',
                this.setting.dine_in_payment_option = response.data.result.dine_in_payment_option??''
            } else {
                error_message(response.data.message);
            }
        })
    },
    fromSubmit(){
        this.$v.setting.$touch()
        if(this.$v.setting.$invalid){
            return false;
        }else{
            settingService.updateSetting({data:this.setting}).then((response) => {
                if (response.data.code === 200) {
                    success_message(response.data.message);
                    this.getSetting()
                } else {
                    error_message(response.data.message);
                }
            })
        }
    },

    getRestaurant(){
        outletService.getRestaurant().then((response) => {
            if(response.data.code == 200){
                let restData = response.data.result.restaurant_settings;
                if(restData.length > 0){
                    restData.forEach((element,key) => {
                        if(element.settings_key &&  element.settings_key == "is_delivery"){
                            this.isDeliveryDisplay = element.setting_values;
                        }
                        if(element.settings_key &&  element.settings_key == "is_pickup"){
                            this.isPickupDisplay = element.setting_values;
                        }
                        if(element.settings_key && element.settings_key == "is_dine_in"){
                            this.isDineinDisplay = element.setting_values;
                        }
                    });
                }                
            }else{
                error_message(response.data.message)
            }
        })
    },
  },

};
</script>

<template>
    <div>
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <form @submit.prevent="fromSubmit">
                            <div class="row">
                                <div class="col-md-6">
                                    <!-- Delivery -->                                    
                                    <div class="row" v-if="isDeliveryDisplay == 'true'">
                                        <div class="col-md-6">
                                            <h5>{{ trans.get('__JSON__.Delivery')}}</h5>
                                        </div>
                                        <div class="col-md-6">
                                            <b-form-select 
                                            v-model="$v.setting.delivery_payment_option.$model"
                                            :options="payment_method_option"
                                            :class="{'is-invalid' : $v.setting.delivery_payment_option.$error}"
                                            ></b-form-select>
                                            <div v-if="$v.setting.delivery_payment_option.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.delivery_payment_option.required">
                                                    {{ trans.get('__JSON__.This field is required') }}
                                                </span>
                                            </div>

                                        </div>
                                    </div>
                                    <!-- Pickup -->
                                    <div class="row mt-4" v-if="isPickupDisplay == 'true'">
                                        <div class="col-md-6">
                                            <h5>{{ trans.get('__JSON__.Pickup')}}</h5>
                                        </div>
                                        <div class="col-md-6">
                                            <b-form-select 
                                            v-model="$v.setting.pickup_payment_option.$model"
                                            :options="payment_method_option"
                                            :class="{'is-invalid' : $v.setting.pickup_payment_option.$error}"
                                            ></b-form-select>
                                            <div v-if="$v.setting.pickup_payment_option.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.pickup_payment_option.required">
                                                    {{ trans.get('__JSON__.This field is required') }}
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                    <!-- Dine in -->
                                    <div class="row mt-4" v-if="isDineinDisplay == 'true'">
                                        <div class="col-md-6">
                                            <h5>{{ trans.get('__JSON__.Dine in')}}</h5>
                                        </div>
                                        <div class="col-md-6">
                                            <b-form-select 
                                            v-model="$v.setting.dine_in_payment_option.$model"
                                            :options="payment_method_option"
                                            :class="{'is-invalid' : $v.setting.dine_in_payment_option.$error}"
                                            ></b-form-select>
                                            <div v-if="$v.setting.dine_in_payment_option.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.dine_in_payment_option.required">{{ trans.get('__JSON__.This field is required') }}</span>
                                            </div>

                                        </div>
                                    </div>
                                </div>
                            </div>
                            <hr>
                            <button type="submit" class="form-controle btn btn-primary" v-if="(isDineinDisplay == 'true' || isPickupDisplay == 'true' || isDeliveryDisplay =='true')">
                                {{ trans.get('__JSON__.Update') }}
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

